#include "MString.h"
#include <iostream>
#include <stdlib.h>
#include <string.h>

MString::MString(unsigned int length)
{
	cp = new char[length];
	len = 0;
	maxlen = length;
}

MString::MString(const char *tempString)
{
	len = strlen(tempString);
	maxlen = len;
	cp = new char[maxlen];
	//strcpy(cp, tempString);
	unsigned int i = 0;
	while(i < maxlen)
	{
		cp[i] = tempString[i];
		i++;
	}
}

MString::MString(char tempChar, unsigned int length)
{
	len = 1;
	maxlen = length;
	cp = new char[maxlen];
	cp[0] = tempChar;
}

MString::MString(const MString &oldString)
{
	len = oldString.length();
	maxlen = oldString.capacity();
	cp = new char[maxlen];
	//strncpy(cp, oldString.get(), maxlen);
	size_t i;
	char *temp = oldString.get();
	for(i = 0; i< maxlen && temp[i] != '\0'; i++)
	{
		cp[i] = temp[i];
	}
}

void MString::conOut() const
{
	unsigned int counter;

	for(counter = 0; counter < len; counter++)
	{
		 std::cout << cp[counter];
	}

	std::cout << std::endl;
}

MString::~MString()
{
	delete[] cp;
	cp = NULL;
}

//operator overloading
MString & MString::operator=(const MString &othString)
{
	if(&othString != this)
	{
		len=othString.length();
		maxlen=othString.capacity();
		if(cp!=NULL)
			delete[] cp;
		cp = new char[maxlen];
		//strncpy(cp,othString.get(),maxlen);
		size_t i;
		char *temp = othString.get();
		for(i = 0; i< maxlen && temp[i] != '\0'; i++)
		{
			cp[i] = temp[i];
		}
	}
	return *this;
}

MString & MString::operator+=(const MString &othString)
{
	//If our Capacity is not enough reserve some new space...
	if(maxlen<(len+othString.length()))
	{
		char *tmp = new char[len+othString.length()];
		//strncpy(tmp,cp,len);
		size_t i;
		for(i = 0; i< len && cp[i] != '\0'; i++)
		{
			tmp[i] = cp[i];
		}
		delete[] cp;
		cp=tmp;
		tmp=NULL;
		maxlen=len+othString.length();
	}
	memcpy(cp+len*sizeof(char),othString.get(),othString.length());
	len=len+othString.length();
	return *this;
}

char & MString::operator[](const unsigned int index)
{
	if(index>len)
	{
		std::cout << "Index out of Range";
		exit(EXIT_FAILURE);
	}
	return cp[index];
}

bool MString::operator==(const MString &othString)
{
	if(len==othString.length())
	{
		if(strncmp(cp,othString.get(),len)==0)
			return true;
	}
	return false;
}


MString operator+(const MString &firstString,const MString &secString)
{
	MString newString(firstString);
	newString+=secString;
	return newString;
}
